import java.io.*;
import java.net.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class AkentiKerberosAppletSeq extends HttpServlet  {

  private String DNameStr,
		 ResourceStr,
		 ConfFileStr,
		 LocalResourceRootStr,
		 UserIDStr,
		 DisplayStr,
		 cmd,
		 action;
  private String AkentiInfo = null;
  boolean AkentiAccessType = false;
  private String Kerb_ticket;
  private String Kerb_directory;
  boolean Kerberos_ticket = false;
  private String Rsh_option;

  public void doPost(HttpServletRequest req, HttpServletResponse res)
         throws ServletException, IOException
  {
    try {
      ObjectInputStream objin = new ObjectInputStream(req.getInputStream());
      Object obj = objin.readObject();
      AkentiInfo = (String)obj;
    } catch (ClassNotFoundException e) { };

    makingandexecutingScript();

    AkentiAccessCheck();
    AkentiResultDelete();

    Kerb_directory = "/project/webflow/users/cyoun/Kerberos/krb5-1.0.6/bin/";
    Rsh_option = "/npac/home/webflow/WebFlow_Server";

    if (AkentiAccessType)
      {
	if(UserIDStr.equals("webflow")) { 

	  Kerberos_kdestroy();
	  Kerberos_kinit();
	  kerberos_ticket_checking();
	  kerberos_ticket_have_it_or_not();
	  kerberosResultDelete();
	  
	  if (Kerberos_ticket) {
	    cmd = "xterm -sb -d "+DisplayStr+" -title "+UserIDStr+" -e "+Kerb_directory+"rsh cygnus.npac.syr.edu -l "+UserIDStr+" -x "+Rsh_option;  
	    try{
	      Process KerberosExec = Runtime.getRuntime().exec(cmd);
	      KerberosExec.waitFor();

	      doGet(req,res);
	    }
	    catch (Exception ex) {
	      System.err.println("Error in executing Kerberos services :"+ex);
	    }
	  }
	  else doGet(req,res); 
	}
	else doGet(req,res); 
      }
    else doGet(req,res);
  }


  public void doGet(HttpServletRequest req, HttpServletResponse res)
          throws ServletException, IOException
  {

    String Result_Denied = null;
    String Kerberos_failed = null;
    String Kerberos_failed1 = null;
    String Kerberos_success = null;

    Result_Denied = "Akenti_Denied";
    Kerberos_failed = "Password_incorrect";
    Kerberos_failed1 = "UserID_failed";
    Kerberos_success = "WebFlow_Server_running";
    
    if (AkentiAccessType) 
      {
	if(UserIDStr.equals("webflow")) { 
	  if (Kerberos_ticket) {
	      if ("object".equals(req.getParameter("format"))) {
	      ObjectOutputStream out5 = new ObjectOutputStream(res.getOutputStream());
	      out5.writeObject(Kerberos_success); } 
	  }
	  else {
	    if ("object".equals(req.getParameter("format"))) {
	      ObjectOutputStream out3 = new ObjectOutputStream(res.getOutputStream());
	      out3.writeObject(Kerberos_failed); }}}
	else {
	    if ("object".equals(req.getParameter("format"))) {
	      ObjectOutputStream out4 = new ObjectOutputStream(res.getOutputStream());
	      out4.writeObject(Kerberos_failed1); }}
      }
    else 
      {
	if ("object".equals(req.getParameter("format"))) {
	ObjectOutputStream out2 = new ObjectOutputStream(res.getOutputStream());
	out2.writeObject(Result_Denied); }}

  }

  public void makingandexecutingScript()
  {
    String dquote = "\"";
    int delimiter1 = 0;
    int delimiter2 = 0;
    int delimiter3 = 0;
    int delimiter4 = 0;
    int delimiter5 = 0;

    delimiter1 = AkentiInfo.indexOf("[Akenti1]");
    delimiter2 = AkentiInfo.indexOf("[Akenti2]");
    delimiter3 = AkentiInfo.indexOf("[Akenti3]");
    delimiter4 = AkentiInfo.indexOf("[Akenti4]");
    delimiter5 = AkentiInfo.indexOf("[Akenti5]");

    DNameStr = AkentiInfo.substring(0, delimiter1);
    ResourceStr = AkentiInfo.substring(delimiter1+9, delimiter2);
    ConfFileStr = AkentiInfo.substring(delimiter2+9, delimiter3);
    LocalResourceRootStr = AkentiInfo.substring(delimiter3+9, delimiter4);
    UserIDStr = AkentiInfo.substring(delimiter4+9, delimiter5);
    DisplayStr = AkentiInfo.substring(delimiter5+9, AkentiInfo.length());

    DNameStr = dquote.concat(DNameStr);
    DNameStr = DNameStr.concat(dquote);

    ResourceStr = dquote.concat(ResourceStr);
    ResourceStr = ResourceStr.concat(dquote);

    cmd = "/npac/home/webflow/Akenti/akenti-docs/cgi-bin/akenti_chk_acc -t W -n "+DNameStr+" -r "+ResourceStr+" -f "+ConfFileStr+" -d "+LocalResourceRootStr+" > /npac/home/webflow/Akenti/akenti-docs/cgi-bin/akentiresult";
    String  Akentiscript = "/npac/home/webflow/Akenti/akenti-docs/cgi-bin/akentiscript";
    
    String FileContents = new String("#!/bin/sh -f\n");
    FileContents += cmd+"\n";
  
    int scriptsize = FileContents.length();
    byte[] scriptbuf = new byte[scriptsize];
    FileContents.getBytes(0, scriptsize, scriptbuf, 0);

    File to_file = new File(Akentiscript);
    FileOutputStream to = null;

    try{
      to = new FileOutputStream(to_file);
      to.write(scriptbuf, 0, scriptsize);
    }
    catch(IOException exc){;}
    finally{
      if(to != null) try{ to.close(); } catch(IOException exc) {;}
    }    

    try{
      Process AkentiEnv = Runtime.getRuntime().exec("chmod 777 "+Akentiscript);
      AkentiEnv.waitFor();
      Process AkentiExec = Runtime.getRuntime().exec(Akentiscript);
      AkentiExec.waitFor();
    }
    catch (Exception ex) {
      //      toClient.println("Error: " + ex.toString()+"<BR>");
    }
  }

  public void AkentiAccessCheck() {

    File f = new File("/npac/home/webflow/Akenti/akenti-docs/cgi-bin/akentiresult");
    int size = (int) f.length();
    int bytes_read = 0;
    String tem_data;

    try{
      FileInputStream in = new FileInputStream(f);
      byte[] data = new byte[size];
      while(bytes_read < size)
	bytes_read += in.read(data, bytes_read, size-bytes_read);
      tem_data = new String(data);
      int indexNum = tem_data.indexOf("Allowed actions:");
      action = tem_data.substring(indexNum+16);

      if (action.startsWith("none")) AkentiAccessType = false;
      else if (action.startsWith("read") || action.startsWith("execute") || action.startsWith("write") || action.startsWith("add") || action.startsWith("delete")) AkentiAccessType = true;
      else AkentiAccessType = false;

    } catch (IOException e) {
      // System.err.println("Error: " + e.toString());
    }
  }

  public void AkentiResultDelete() {
    
    String  Akentiresult = "/npac/home/webflow/Akenti/akenti-docs/cgi-bin/akentiresult";
    String  Akentiscript = "/npac/home/webflow/Akenti/akenti-docs/cgi-bin/akentiscript";
 
    try{
      Process AkentiDelete = Runtime.getRuntime().exec("rm -r "+Akentiresult);
      AkentiDelete.waitFor(); 
      Process AkentiSDelete = Runtime.getRuntime().exec("rm -r "+Akentiscript);
      AkentiDelete.waitFor(); 
    }
    catch (Exception ex1) {
      //System.err.println("Error: " + ex1.toString());
    }
  }

  public void Kerberos_kinit()
  {
    cmd = "xterm -sb -d "+DisplayStr+" -title "+UserIDStr+" -e "+Kerb_directory+"kinit -f "+UserIDStr;

    try{
      Process Kerberos_kinitExec = Runtime.getRuntime().exec(cmd);
      Kerberos_kinitExec.waitFor();
    }
    catch (Exception ex) {
      System.err.println("Error in generating Kerberos ticket :"+ex);
    }
  }

  public void Kerberos_kdestroy()
  {
    cmd =" "+Kerb_directory+"kdestroy";

    try{
      Process Kerberos_kdestroyExec = Runtime.getRuntime().exec(cmd);
      Kerberos_kdestroyExec.waitFor();
    }
    catch (Exception ex) {
      System.err.println("Error in deleting Kerberos ticket :"+ex);
    }
  }

  public void kerberos_ticket_checking()
  {

    cmd = " "+Kerb_directory+"klist > /npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/servlets/kerberosresult_ticket";
    String  Kerberosscript = "/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/servlets/kerberosscript_ticket";
    
    String FileContents = new String("#!/bin/sh -f\n");
    FileContents += cmd+"\n";
  
    int scriptsize = FileContents.length();
    byte[] scriptbuf = new byte[scriptsize];
    FileContents.getBytes(0, scriptsize, scriptbuf, 0);

    File to_file = new File(Kerberosscript);
    FileOutputStream to = null;

    try{
      to = new FileOutputStream(to_file);
      to.write(scriptbuf, 0, scriptsize);
    }
    catch(IOException exc){;}
    finally{
      if(to != null) try{ to.close(); } catch(IOException exc) {;}
    }    

    try{
      Process KerberosEnv = Runtime.getRuntime().exec("chmod 777 "+Kerberosscript);
      KerberosEnv.waitFor();
      Process KerberosExec = Runtime.getRuntime().exec(Kerberosscript);
      KerberosExec.waitFor();
    }
    catch (Exception ex) {
      System.err.println("Error: " + ex.toString());
    }
  }

  public void kerberos_ticket_have_it_or_not() {

    File f = new File("/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/servlets/kerberosresult_ticket");
    int size = (int) f.length();
    int bytes_read = 0;
    String tem_data;

    try{
      FileInputStream in = new FileInputStream(f);
      byte[] data = new byte[size];
      while(bytes_read < size)
        bytes_read += in.read(data, bytes_read, size-bytes_read);
      tem_data = new String(data);
      int indexNum = tem_data.indexOf("Default principal: ");

      if (indexNum == -1) Kerberos_ticket = false;
      else {
	action = tem_data.substring(indexNum+19);

	if (action.startsWith(UserIDStr)) Kerberos_ticket = true;

	else Kerberos_ticket = false; }

    } catch (IOException e) {
      System.err.println("Error: " + e.toString());
    }
  }

  public void kerberosResultDelete() {
    
    String  Kerberosresult = "/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/servlets/kerberosresult_ticket";
    String  Kerberosscript = "/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/servlets/kerberosscript_ticket";
 
    try{
      Process KerberosDelete = Runtime.getRuntime().exec("rm -r "+Kerberosresult);
      KerberosDelete.waitFor(); 
      Process KerberosSDelete = Runtime.getRuntime().exec("rm -r "+Kerberosscript);
      KerberosSDelete.waitFor(); 
    }
    catch (Exception ex1) {
      System.err.println("Error: " + ex1.toString());
    }
  }

  public String getServletInfo() {
    return "Checking access as Akenti Security Servlet";
  }

}

























